/*
 * Wrapper for document.cookie which provide simple API to get / set / delete cookies.
 *
 * http://www.zahodi-ka.ru/doc/tech/cookie.shtml
 * Copyright 2013 Konstantin Aleksandrov
 */
if (!document.kuki)
{
    document.kuki = new function()
    {
        var kuki_raw, kukis;
        
        refresh = function(a)
        {
            if (kuki_raw === document.cookie) return;
            kuki_raw = document.cookie;
            var kukis_str = kuki_raw.split(/\s*;\s*/);
            kukis = [];
            for (var i = 0; i < kukis_str.length; i++)
            {
                var kuki_str = kukis_str[i].split(/\s*=\s*/);
                var kuki = { name : decodeURIComponent(kuki_str[0]) };
                if (kuki_str.length > 1)
                    kuki.value = decodeURIComponent(kuki_str[1]);
                kukis.push(kuki);
            }
        };
        
        this.set = function(kuki)
        {
            if (!kuki.name) throw new TypeError('Cookie name does not specified');
            for (var attr in { domain : 1, path : 1, 'max-age' : 1})
            {
                if (kuki[attr] && kuki[attr].toString().match(/[=;]/))
                    throw new TypeError('Incorrect value of cookie "' + attr +
                                        '" attribute: "' + kuki[attr] + '"');
            }

            var name = encodeURIComponent(kuki.name);
            var value = kuki.value != undefined ?
                encodeURIComponent(kuki.value.toString()) : undefined;

            var exp = kuki.expires;
            if (exp && exp.constructor === Date) exp = exp.toUTCString();
            
            document.cookie =
                name + '=' +
                (value ? value : '') + ';' +
                (exp ? 'expires=' + exp + ';' : '') +
                (kuki['max-age'] ? 'max-age=' + kuki['max-age'] + ';' : '') +
                (kuki.domain ? 'domain=' + kuki.domain + ';' : '') +
                (kuki.path ? 'path=' + kuki.path + ';' : '') +
                (kuki.sequre ? 'Secure;' : '') +
                (kuki.httponly ? 'HttpOnly;' : '');
            
            refresh();
        };

        this.gets = function(name)
        {
            refresh();
            var values = [];
            for (var i = 0; i < kukis.length; i++)
                if (kukis[i].name == name) values.push(kukis[i].value);
            return values;
        };

        this.get = function(name)
        {
            var values = this.gets(name);
            return values.length ? values[0] : undefined;
        };

        this.has = function(name)
        {
            refresh();
            for (var i = 0; i < kukis.length; i++)
                if (kukis[i].name == name) return true;
            return false;
        };

        this.delete = function(kuki)
        {
            this.set({
                name : kuki.name,
                domain : kuki.domain,
                path : kuki.path,
                expires : 'Wed, 12 Apr 1961 05:07:00 GMT'});
        };
    };
}
